pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node Class Reference

`#include <pcl/recognition/ransac_based/simple_octree.h>`

## Public Member Functions

| Node ()
virtual | ~ Node ()
void | setCenter (const Scalar *c)
void | setBounds (const Scalar *b)
const Scalar * | getCenter () const
const Scalar * | getBounds () const
void | getBounds (Scalar b[6]) const
Node * | getChild (int id)
Node * | getChildren ()
void | setData (const NodeData &src)
NodeData & | getData ()
const NodeData & | getData () const
Node * | getParent ()
float | getRadius () const
bool | hasData ()
bool | hasChildren ()
const std::set< Node * > & | getNeighbors () const
void | deleteChildren ()
void | deleteData ()

## Protected Member Functions

void | setData (NodeData *data)
bool | createChildren ()
void | makeNeighbors (Node *node)
| Make this and 'node' neighbors by inserting each node in the others node neighbor set. More...
void | setParent (Node *parent)
void | computeRadius ()
| Computes the "radius" of the node which is half the diagonal length. More...

## Protected Attributes

NodeData * | data_
Scalar | center_ [3]
Scalar | bounds_ [6]
Node * | parent_
Node * | children_
Scalar | radius_
std::set< Node * > | full_leaf_neighbors_

## Friends

class | SimpleOctree

## Detailed Description

### template<typename NodeData, typename NodeDataCreator, typename Scalar = float>
class pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node

Definition at line 61 of file simple_octree.h.

## Constructor & Destructor Documentation

## Node()

template<typename NodeData , typename NodeDataCreator , typename Scalar >

pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::Node

inline

Definition at line 21 of file simple_octree.hpp.

## ~ Node()

template<typename NodeData , typename NodeDataCreator , typename Scalar = float>

virtual pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::~ Node | ( |  | ) |

## Member Function Documentation

## computeRadius()

template<typename NodeData , typename NodeDataCreator , typename Scalar >

void pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::computeRadius

inline protected

Computes the "radius" of the node which is half the diagonal length.

Definition at line 58 of file simple_octree.hpp.

References pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::bounds_.

## createChildren()

template<typename NodeData , typename NodeDataCreator , typename Scalar >

bool pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::createChildren

inline protected

Definition at line 69 of file simple_octree.hpp.

Referenced by pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::createLeaf().

## deleteChildren()

template<typename NodeData , typename NodeDataCreator , typename Scalar >

void pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::deleteChildren

inline

Definition at line 156 of file simple_octree.hpp.

## deleteData()

template<typename NodeData , typename NodeDataCreator , typename Scalar >

void pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::deleteData

inline

Definition at line 164 of file simple_octree.hpp.

## getBounds() [1/2]

template<typename NodeData , typename NodeDataCreator , typename Scalar = float>

const Scalar* pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::getBounds | ( |  | ) | const

inline

Definition at line 78 of file simple_octree.h.

## getBounds() [2/2]

template<typename NodeData , typename NodeDataCreator , typename Scalar = float>

void pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::getBounds | ( | Scalar | b[6] | ) | const

inline

Definition at line 81 of file simple_octree.h.

## getCenter()

template<typename NodeData , typename NodeDataCreator , typename Scalar = float>

const Scalar* pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::getCenter | ( |  | ) | const

inline

Definition at line 75 of file simple_octree.h.

Referenced by pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::createLeaf(), pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::getFullLeaf(), and pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::insertNeighbors().

## getChild()

template<typename NodeData , typename NodeDataCreator , typename Scalar = float>

Node* pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::getChild | ( | int | id | ) |

inline

Definition at line 84 of file simple_octree.h.

Referenced by pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::createLeaf(), and pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::getFullLeaf().

## getChildren()

template<typename NodeData , typename NodeDataCreator , typename Scalar = float>

Node* pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::getChildren | ( |  | ) |

inline

Definition at line 87 of file simple_octree.h.

## getData() [1/2]

template<typename NodeData , typename NodeDataCreator , typename Scalar = float>

NodeData& pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::getData | ( |  | ) |

inline

Definition at line 93 of file simple_octree.h.

## getData() [2/2]

template<typename NodeData , typename NodeDataCreator , typename Scalar = float>

const NodeData& pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::getData | ( |  | ) | const

inline

Definition at line 96 of file simple_octree.h.

## getNeighbors()

template<typename NodeData , typename NodeDataCreator , typename Scalar = float>

const std::set<Node*>& pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::getNeighbors | ( |  | ) | const

inline

Definition at line 111 of file simple_octree.h.

## getParent()

template<typename NodeData , typename NodeDataCreator , typename Scalar = float>

Node* pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::getParent | ( |  | ) |

inline

Definition at line 99 of file simple_octree.h.

## getRadius()

template<typename NodeData , typename NodeDataCreator , typename Scalar = float>

float pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::getRadius | ( |  | ) | const

inline

Definition at line 102 of file simple_octree.h.

## hasChildren()

template<typename NodeData , typename NodeDataCreator , typename Scalar = float>

bool pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::hasChildren | ( |  | ) |

inline

Definition at line 108 of file simple_octree.h.

Referenced by pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::getFullLeaf().

## hasData()

template<typename NodeData , typename NodeDataCreator , typename Scalar = float>

bool pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::hasData | ( |  | ) |

inline

Definition at line 105 of file simple_octree.h.

Referenced by pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::createLeaf(), and pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::getFullLeaf().

## makeNeighbors()

template<typename NodeData , typename NodeDataCreator , typename Scalar >

void pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::makeNeighbors | ( | Node * | node | ) |

inline protected

Make this and 'node' neighbors by inserting each node in the others node neighbor set.

Nothing happens of either of the nodes has no data.

Definition at line 172 of file simple_octree.hpp.

Referenced by pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::insertNeighbors().

## setBounds()

template<typename NodeData , typename NodeDataCreator , typename Scalar >

void pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::setBounds | ( | const Scalar * | b | ) |

inline

Definition at line 46 of file simple_octree.hpp.

References pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::bounds_.

## setCenter()

template<typename NodeData , typename NodeDataCreator , typename Scalar >

void pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::setCenter | ( | const Scalar * | c | ) |

inline

Definition at line 37 of file simple_octree.hpp.

## setData() [1/2]

template<typename NodeData , typename NodeDataCreator , typename Scalar = float>

void pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::setData | ( | const NodeData & | src | ) |

inline

Definition at line 90 of file simple_octree.h.

Referenced by pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::createLeaf().

## setData() [2/2]

template<typename NodeData , typename NodeDataCreator , typename Scalar = float>

void pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::setData | ( | NodeData * | data | ) |

inline protected

Definition at line 123 of file simple_octree.h.

## setParent()

template<typename NodeData , typename NodeDataCreator , typename Scalar = float>

void pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::setParent | ( | Node * | parent | ) |

inline protected

Definition at line 134 of file simple_octree.h.

## Friends And Related Function Documentation

## SimpleOctree

template<typename NodeData , typename NodeDataCreator , typename Scalar = float>

friend class SimpleOctree

friend

Definition at line 119 of file simple_octree.h.

## Member Data Documentation

## bounds_

template<typename NodeData , typename NodeDataCreator , typename Scalar = float>

Scalar pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::bounds_[6]

protected

Definition at line 142 of file simple_octree.h.

## center_

template<typename NodeData , typename NodeDataCreator , typename Scalar = float>

Scalar pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::center_[3]

protected

Definition at line 142 of file simple_octree.h.

## children_

template<typename NodeData , typename NodeDataCreator , typename Scalar = float>

Node * pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::children_

protected

Definition at line 143 of file simple_octree.h.

## data_

template<typename NodeData , typename NodeDataCreator , typename Scalar = float>

NodeData* pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::data_

protected

Definition at line 141 of file simple_octree.h.

## full_leaf_neighbors_

template<typename NodeData , typename NodeDataCreator , typename Scalar = float>

std::set<Node*> pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::full_leaf_neighbors_

protected

Definition at line 145 of file simple_octree.h.

## parent_

template<typename NodeData , typename NodeDataCreator , typename Scalar = float>

Node* pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::parent_

protected

Definition at line 143 of file simple_octree.h.

## radius_

template<typename NodeData , typename NodeDataCreator , typename Scalar = float>

Scalar pcl::recognition::SimpleOctree< NodeData, NodeDataCreator, Scalar >::Node::radius_

protected

Definition at line 144 of file simple_octree.h.

The documentation for this class was generated from the following files:

- pcl/recognition/ransac_based/simple_octree.h
- pcl/recognition/impl/ransac_based/simple_octree.hpp